mod Ex02a logic: 'cl'

incl Mtex

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 1.3.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para deklaratívne programovanie: rekurzia s mierou a iteratívna 
         rekurzia, 
   \item \para logická platnosť a logické vyplývanie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Course of Values Recursion with Substitution in 
  Parameters.  \end 

rem 
  \para \bf  Divisibility predicate.  \end 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> \e z y = x*z

rem 
  \para \bf  Greatest common divisor.  \end 
  \header* fun/2 Gcd 'Tex_f2_n_gcd' \end Specification of the greatest common 
  divisor function \ft Gcd(x,y) \end: 
  \eq* 
    x != 0 \/ y != 0 -> Divides(Gcd(x,y),x) & Divides(Gcd(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd(x,y)
  \end

rem 
  \para \bf  Euclidean algorithm I.  \end \header* fun/2 Gcd 'Tex_f2_n_gcd' \end 
  Find a course of values recursive definition of \ft Gcd(x,y) \end based on the 
  property 
  \eq* 
    x != 0 & Divides(z,x) -> Divides(z,y) <-> Divides(z,y mod x)
  \end

fun/2 Gcd1 'Tex_f2_n_gcd'
  Gcd1(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Maximum.  \end 

fun/2 Max 'Tex_f2_n_max'
  Max(x,y) = x <- x >= y
  Max(x,y) = y <- x < y

rem 
  \para \bf  Euclidean algorithm II.  \end 
  \header* fun/2 Gcd 'Tex_f2_n_gcd' \end Find a course of values recursive 
  definition of \ft Gcd(x,y) \end based on the property 
  \eq* 
    x < y & Divides(z,x) -> Divides(z,y) <-> Divides(z,y-x)
  \end
  \para \it  [CL] Remark.  \end Note that we have 
  \eq* 
    x = 0 \/ y = 0 -> Gcd(x,y) = Max(x,y)
  \end

fun/2 Gcd2 'Tex_f2_n_gcd'
  Gcd2(x,y) = Max(x,y) <- x = 0
  Gcd2(x,y) = Max(x,y) <- x != 0 & y = 0
  Gcd2(x,y) = Foo <- x != 0 & y != 0

rem 
  \para \bf  Section. Iterative Recursion.  \end See also in [1]: 
  \items 
   \item \para the paragraph \it  Fibonacci function  \end in the section \it  
         Primitive Recursion  \end and 
   \item \para the paragraph \it  Simulation of for-loops by recursion  \end in 
         the section \it  Course of Values Recursion  \end. 
  \end

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the function: 

fun F1 'Tex_f1_f_sub'
  F1(0) = 0
  F1(1) = 1
  F1(n+2) = F1(n+1)+F1(n)

rem 
  \para Your solution should simulate the following while-loop by primitive 
  recursion with substitution in parameters: 
  \verbatim 
  def f(n):
      if n == 0:
          return 0
      else:
          n,a,b = n-1,1,0
          while n != 0:
              n,a,b = n-1,a+b,a
          return a
  \end

rem 
  \para \it  While-loop by primitive recursion with substitution in parameters. 
   \end 

fun/3 While1 'Tex_f3_g'
  While1(n,a,b) = Foo

rem 
  \para Invariant: 
  \eq* 
    While1(n,F1(k+1),F1(k)) = F1(n+1+k)
  \end

fun F1_efficient 'Tex_f1_f_sub'
  F1_efficient(n) = Foo

rem 
  \para \bf  Exercise.  \end Find a similar tail recursive implementation of the 
  next function: 

fun F2 'Tex_f1_f_sub'
  F2(0) = 0
  F2(1) = 1
  F2(2) = 2
  F2(n+3) = F2(n+2)+F2(n+1)+F2(n)

rem 
  \para \it  While-loop by primitive recursion with substitution in parameters. 
   \end 

fun/4 While2 'Tex_f4_g'
  While2(n,a,b,c) = Foo

rem 
  \para Invariant: 
  \eq* 
    While2(n,F2(k+2),F2(k+1),F2(k)) = F2(n+2+k)
  \end

fun F2_efficient 'Tex_f1_f_sub'
  F2_efficient(n) = Foo

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the function: 

fun F3 'Tex_f1_f_sub'
  F3(0) = 0
  F3(1) = 1
  F3(n+2) = F3(n+1)+F3(n)+n

rem 
  \para Your solution should simulate the following for-loop by backward 
  recursion with substitution in parameters: 
  \verbatim 
  def f(n):
      if n == 0:
          return 0
      else:
          n,a,b = n-1,1,0
          for i in range(0,n):
              a,b = a+b+i,a
          return a
  \end

rem 
  \para \it  For-loop by backward recursion with substitution in parameters. 
   \end 

fun/4 For3 'Tex_f4_g'
  For3(i,n,a,b) = Foo

rem 
  \para Invariant: 
  \eq* 
    i <= n -> For3(i,n,F3(i+1),F3(i)) = F3(n+1)
  \end

fun F3_efficient 'Tex_f1_f_sub'
  F3_efficient(n) = Foo

rem 
  \para \bf  Exercise.  \end Find a similar tail recursive implementation of the 
  next function: 

fun F4 'Tex_f1_f_sub'
  F4(0) = 0
  F4(1) = 1
  F4(2) = 2
  F4(n+3) = F4(n+2)+F4(n+1)+F4(n)+n

rem 
  \para \it  For-loop by backward recursion with substitution in parameters. 
   \end 

fun/5 For4 'Tex_f5_g'
  For4(i,n,a,b,c) = Foo

rem 
  \para Invariant: 
  \eq* 
    i <= n -> For4(i,n,F4(i+2),F4(i+1),F4(i)) = F4(n+2)
  \end

fun F4_efficient 'Tex_f1_f_sub'
  F4_efficient(n) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

