mod Ex02b logic: 'cl'

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 1.3.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para deklaratívne programovanie: rekurzia s mierou a iteratívna 
         rekurzia, 
   \item \para logická platnosť a logické vyplývanie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Quantification Logic.  \end 

rem 
  \para \bf  Section. Quantification Tableaux.  \end 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicq  \end in the file \it  
  mlogicq.cl  \end contains the syntax of tableau rules for quantifier tableaux. 

theory Examples logic: 'fol_yeq_min'

pred/2 R 

rem 
  \para \bf  Exercise.  \end Prove the following sentence: 
  \eq* 
    \e y\a xR(x,y) -> \a x\e yR(x,y)
  \end

thm Exists_forall
  \e y\a xR(x,y) -> \a x\e yR(x,y)

pred A 

pred B 

rem 
  \para \bf  Exercise.  \end Prove the following sentences: 
  \eq* 
    \e x(A(x) & B(x)) -> \e xA(x) & \e xB(x)
  \end
  \eq* 
    \a xA(x) \/ \a xB(x) -> \a x(A(x) \/ B(x))
  \end
  \eq* 
    ~\e xA(x) <-> \a x~A(x)
  \end

thm Exists_and
  \e x(A(x) & B(x)) -> \e xA(x) & \e xB(x)

thm Forall_or
  \a xA(x) \/ \a xB(x) -> \a x(A(x) \/ B(x))

thm Not_exists
  ~\e xA(x) <-> \a x~A(x)

end theory Examples

rem 
  \para \bf  Section. Logical Consequence.  \end 

rem 
  \para \bf  [CL] Remark.  \end In the following examples you can use derived 
  quantifier tableau rules as described in the module \it  Mlogicd  \end (see 
  the file \it  mlogicd.cl  \end). 

theory Predicate_is_reflexive logic: 'fol_def'

pred/2 R 

rem 
  \para \bf  Exercise.  \end Suppose that the binary predicate \ft R(x,y) \end 
  is symmetric and transitive: 

axiom Symmetry
  \a x\a y(R(x,y) -> R(y,x))

axiom Transitivity
  \a x\a y\a z(R(x,y) & R(y,z) -> R(x,z))

rem 
  \para Show that the predicate is reflexive on its domain of definition: 

thm Reflexivity
  \a x(\e yR(x,y) -> R(x,x))

end theory Predicate_is_reflexive

theory Predicate_is_asymmetric logic: 'fol_def'

pred/2 R 

rem 
  \para \bf  Exercise.  \end Suppose that the binary predicate \ft R(x,y) \end 
  is ireflexive and transitive: 

axiom Ireflexivity
  \a x~R(x,x)

axiom Transitivity
  \a x\a y\a z(R(x,y) & R(y,z) -> R(x,z))

rem 
  \para Show that the predicate is asymmetric: 

thm Asymmetry
  \a x\a y(R(x,y) -> ~R(y,x))

end theory Predicate_is_asymmetric

theory Predicate_is_identity logic: 'fol_def'

pred/2 R 

rem 
  \para \bf  Exercise.  \end Suppose that the binary predicate \ft R(x,y) \end 
  is symmetric and antisymmetric: 

axiom Symmetry
  \a x\a y(R(x,y) -> R(y,x))

axiom Antisymmetry
  \a x\a y(R(x,y) & R(y,x) -> x = y)

rem 
  \para Show that the predicate is the identity on its domain of definition: 

thm Identity
  \a x\a y(R(x,y) -> x = y)

end theory Predicate_is_identity

theory Equivalence_alternative_definition_of1

pred/2 R 

rem 
  \para \bf  Exercise.  \end Suppose that the binary predicate \ft R(x,y) \end 
  is equivalence: 

axiom Reflexivity
  \a xR(x,x)

axiom Symmetry
  \a x\a y(R(x,y) -> R(y,x))

axiom Transitivity
  \a x\a y\a z(R(x,y) & R(y,z) -> R(x,z))

rem 
  \para Show that the predicate satisfies the property: 

thm Alternative_definition
  \a x\a y(R(x,y) <-> \a z(R(x,z) <-> R(y,z)))

end theory Equivalence_alternative_definition_of1

theory Equivalence_alternative_definition_of2

pred/2 R 

rem 
  \para \bf  Exercise.  \end Suppose that the binary predicate \ft R(x,y) \end 
  satisfies the property: 

axiom Alternative_definition
  \a x\a y(R(x,y) <-> \a z(R(x,z) <-> R(y,z)))

rem 
  \para Show that the predicate is equivalence: 

thm Reflexivity
  \a xR(x,x)

thm Symmetry
  \a x\a y(R(x,y) -> R(y,x))

thm Transitivity
  \a x\a y\a z(R(x,y) & R(y,z) -> R(x,z))

end theory Equivalence_alternative_definition_of2

